﻿using System;
using System.Diagnostics.Contracts;

namespace Demo.CodeContracts
{
    public class Node
    {
        private readonly object _value;

        public Node(object value, Node next)
        {
            Contract.Requires<ArgumentNullException>(value != null);

            _value = value;
            Next = next;
        }

        public object Value
        {
            get
            {
                Contract.Ensures(Contract.Result<object>() != null);
                return _value;
            }
        }

        public Node Next { get; internal set; }

        public override string ToString()
        {
            return _value.ToString();
        }

        [ContractInvariantMethod]
        private void InvariantMethod()
        {
            Contract.Invariant(_value != null);
        }
    }
}