﻿using System;
using System.Diagnostics.Contracts;
using System.Threading.Tasks;

namespace Demo.CodeContracts
{
    class Program
    {
        static void Main()
        {
            var linkedList = new LinkedList();
            linkedList.InsertAt(0, "bbb");
            Contract.Assume(linkedList.Count == 1);
            linkedList.InsertAt(1, "ccc");
            linkedList.InsertAt(0, "aaa");
            //linkedList.InsertAt(0, null);

            Console.WriteLine("Count: {0}", linkedList.Count);
            Console.WriteLine();

            Contract.Assume(linkedList.Count == 3);
            string s = linkedList.ValueAt(1).ToString();
            Console.WriteLine("Value[1]: {0}", s);
            Console.WriteLine();

            Console.WriteLine("Value[Count-1]: {0}", linkedList.ValueAt(linkedList.Count - 1));
            //Console.WriteLine("Value[Count]: {0}", linkedList.ValueAt(linkedList.Count));
            //Console.WriteLine("Value[8]: {0}", linkedList.ValueAt(-2));
            //Console.WriteLine("Value[8]: {0}", linkedList.ValueAt(8));
            Console.WriteLine();

            CallNodeOfAsync(linkedList).Wait();
            Console.WriteLine();

            Node node = linkedList.FirstNode.Next;
            while (node != null)
            {
                Console.WriteLine(node.Value);
                node = node.Next;
            }
            Console.ReadLine();
        }

        private static async Task CallNodeOfAsync(LinkedList linkedList)
        {
            Node node = await linkedList.NodeOfAsync("ccc");
            Console.WriteLine("Async Value of NodeOf \"ccc\": {0}", node.Value);
        }
    }
}
